# ----------------------------------------------------------------------
#  MAIN PROGRAM - generated by the Rappture Builder
# ----------------------------------------------------------------------
import Rappture
import sys
import os
import string
import numpy as np
from Rappture.tools import getCommandOutput as RapptureExec
import shutil
import math
global str


# uncomment these to redirect stdout and stderr
# to files for debugging.
#sys.stderr = open('debug.err', 'w')
#sys.stdout = open('debug.out', 'w')

# open the XML file containing the run parameters
io = Rappture.PyXml(sys.argv[1])

#########################################################
# Get input values from Rappture
#########################################################

# get input value for input.group(value35).note(value36)
value36 = io['input.group(value35).note(value36).current'].value

# get input value for input.group(group_inputs).number(start_x) and convert to m
str = io['input.group(group_inputs).number(start_x).current'].value
start_x = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(group_inputs).number(start_y) and convert to m
str = io['input.group(group_inputs).number(start_y).current'].value
start_y = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(group_inputs).number(end_x) and convert to m
str = io['input.group(group_inputs).number(end_x).current'].value
end_x = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(group_inputs).number(end_y) and convert to m
str = io['input.group(group_inputs).number(end_y).current'].value
end_y = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(group_inputs).integer(grid_x)
grid_x = int(io['input.group(group_inputs).integer(grid_x).current'].value)

# get input value for input.group(group_inputs).integer(grid_y)
grid_y = int(io['input.group(group_inputs).integer(grid_y).current'].value)

# get input value for input.group(boundary).choice(xlo)
xlo = io['input.group(boundary).choice(xlo).current'].value

# get input value for input.group(boundary).choice(xhi)
xhi = io['input.group(boundary).choice(xhi).current'].value

# get input value for input.group(boundary).choice(ylo)
ylo = io['input.group(boundary).choice(ylo).current'].value

# get input value for input.group(boundary).choice(yhi)
yhi = io['input.group(boundary).choice(yhi).current'].value

# get input value for input.group(surface).number(xlo_s) and convert to m
str = io['input.group(surface).number(xlo_s).current'].value
xlo_s = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(surface).number(ylo_s) and convert to m
str = io['input.group(surface).number(ylo_s).current'].value
ylo_s = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(surface).number(xhi_s) and convert to m
str = io['input.group(surface).number(xhi_s).current'].value
xhi_s = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(surface).number(yhi_s) and convert to m
str = io['input.group(surface).number(yhi_s).current'].value
yhi_s = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(surface).boolean(value29)
# returns value as string "yes" or "no"
value29 = io['input.group(surface).boolean(value29).current'].value == 'yes'

# get input value for input.group(surface).number(xlo_2s) and convert to m
str = io['input.group(surface).number(xlo_2s).current'].value
xlo_2s = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(surface).number(ylo_2s) and convert to m
str = io['input.group(surface).number(ylo_2s).current'].value
ylo_2s = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(surface).number(xhi_2s) and convert to m
str = io['input.group(surface).number(xhi_2s).current'].value
xhi_2s = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(surface).number(yhi_2s) and convert to m
str = io['input.group(surface).number(yhi_2s).current'].value
yhi_2s = Rappture.Units.convert(str, to="m", units="off")

# get input value for input.group(sim_par).boolean(value38)
# returns value as string "yes" or "no"
value38 = io['input.group(sim_par).boolean(value38).current'].value == 'yes'

# get input value for input.group(sim_par).number(nrho)
nrho = float(io['input.group(sim_par).number(nrho).current'].value)

# get input value for input.group(sim_par).number(press) and convert to Pa
str = io['input.group(sim_par).number(press).current'].value
press = Rappture.Units.convert(str, to="Pa", units="off")

# get input value for input.group(sim_par).integer(num)
num = int(io['input.group(sim_par).integer(num).current'].value)

# get input value for input.group(sim_par).choice(air)
air = io['input.group(sim_par).choice(air).current'].value

# get input value for input.group(sim_par).number(temp_stream) and convert to K
str = io['input.group(sim_par).number(temp_stream).current'].value
temp_stream = Rappture.Units.convert(str, to="K", units="off")

# get input value for input.group(sim_par).number(timestep) and convert to s
str = io['input.group(sim_par).number(timestep).current'].value
timestep = Rappture.Units.convert(str, to="s", units="off")

# get input value for input.group(sim_par).number(run)
run = float(io['input.group(sim_par).number(run).current'].value)

# get input value for input.group(sim_par).boolean(flow)
# returns value as string "yes" or "no"
flow = io['input.group(sim_par).boolean(flow).current'].value == 'yes'

# get input value for input.group(sim_par).integer(create_par)
create_par = int(io['input.group(sim_par).integer(create_par).current'].value)

# get input value for input.group(surface).group(group_surface_collision).boolean(value30)
# returns value as string "yes" or "no"
value30 = io['input.group(surface).group(group_surface_collision).boolean(value30).current'].value == 'yes'

# get input value for input.group(surface).group(group_surface_collision).number(temp_square) and convert to K
str = io['input.group(surface).group(group_surface_collision).number(temp_square).current'].value
temp_square = Rappture.Units.convert(str, to="K", units="off")

# get input value for input.group(surface).group(group_surface_collision).number(acc_square)
acc_square = float(io['input.group(surface).group(group_surface_collision).number(acc_square).current'].value)

# get input value for input.group(sim_par).group(group_vel).number(vel_x) and convert to m/s
str = io['input.group(sim_par).group(group_vel).number(vel_x).current'].value
vel_x = Rappture.Units.convert(str, to="m/s", units="off")

# get input value for input.group(sim_par).group(group_vel).number(vel_y) and convert to m/s
str = io['input.group(sim_par).group(group_vel).number(vel_y).current'].value
vel_y = Rappture.Units.convert(str, to="m/s", units="off")

# get input value for input.group(sim_par).group(inflow_group).boolean(xlo_flow)
# returns value as string "yes" or "no"
xlo_flow = io['input.group(sim_par).group(inflow_group).boolean(xlo_flow).current'].value == 'yes'

# get input value for input.group(sim_par).group(inflow_group).boolean(ylo_flow)
# returns value as string "yes" or "no"
ylo_flow = io['input.group(sim_par).group(inflow_group).boolean(ylo_flow).current'].value == 'yes'

# get input value for input.group(sim_par).group(inflow_group).boolean(xhi_flow)
# returns value as string "yes" or "no"
xhi_flow = io['input.group(sim_par).group(inflow_group).boolean(xhi_flow).current'].value == 'yes'

# get input value for input.group(sim_par).group(inflow_group).boolean(yhi_flow)
# returns value as string "yes" or "no"
yhi_flow = io['input.group(sim_par).group(inflow_group).boolean(yhi_flow).current'].value == 'yes'

# get input value for input.group(sim_par).group(output).string(output_grid)
output_grid = io['input.group(sim_par).group(output).string(output_grid).current'].value

# get input value for input.group(sim_par).group(output).string(output_surf)
output_surf = io['input.group(sim_par).group(output).string(output_surf).current'].value

# get input value for input.group(boundary).group(surf).group(group_surf_xlo).boolean(bound_collide_xlo)
# returns value as string "yes" or "no"
bound_collide_xlo = io['input.group(boundary).group(surf).group(group_surf_xlo).boolean(bound_collide_xlo).current'].value == 'yes'

# get input value for input.group(boundary).group(surf).group(group_surf_xlo).number(temp_boundary_xlo) and convert to K
str = io['input.group(boundary).group(surf).group(group_surf_xlo).number(temp_boundary_xlo).current'].value
temp_boundary_xlo = Rappture.Units.convert(str, to="K", units="off")

# get input value for input.group(boundary).group(surf).group(group_surf_xlo).number(acc_boundary_xlo)
acc_boundary_xlo = float(io['input.group(boundary).group(surf).group(group_surf_xlo).number(acc_boundary_xlo).current'].value)

# get input value for input.group(boundary).group(surf).group(group_surf_xhi).boolean(bound_collide_xhi)
# returns value as string "yes" or "no"
bound_collide_xhi = io['input.group(boundary).group(surf).group(group_surf_xhi).boolean(bound_collide_xhi).current'].value == 'yes'

# get input value for input.group(boundary).group(surf).group(group_surf_xhi).number(temp_boundary_xhi) and convert to K
str = io['input.group(boundary).group(surf).group(group_surf_xhi).number(temp_boundary_xhi).current'].value
temp_boundary_xhi = Rappture.Units.convert(str, to="K", units="off")

# get input value for input.group(boundary).group(surf).group(group_surf_xhi).number(acc_boundary_xhi)
acc_boundary_xhi = float(io['input.group(boundary).group(surf).group(group_surf_xhi).number(acc_boundary_xhi).current'].value)

# get input value for input.group(boundary).group(surf).group(group_surf_ylo).boolean(bound_collide_ylo)
# returns value as string "yes" or "no"
bound_collide_ylo = io['input.group(boundary).group(surf).group(group_surf_ylo).boolean(bound_collide_ylo).current'].value == 'yes'

# get input value for input.group(boundary).group(surf).group(group_surf_ylo).number(temp_boundary_ylo) and convert to K
str = io['input.group(boundary).group(surf).group(group_surf_ylo).number(temp_boundary_ylo).current'].value
temp_boundary_ylo = Rappture.Units.convert(str, to="K", units="off")

# get input value for input.group(boundary).group(surf).group(group_surf_ylo).number(acc_boundary_ylo)
acc_boundary_ylo = float(io['input.group(boundary).group(surf).group(group_surf_ylo).number(acc_boundary_ylo).current'].value)

# get input value for input.group(boundary).group(surf).group(group_surf_yhi).boolean(bound_collide_yhi)
# returns value as string "yes" or "no"
bound_collide_yhi = io['input.group(boundary).group(surf).group(group_surf_yhi).boolean(bound_collide_yhi).current'].value == 'yes'

# get input value for input.group(boundary).group(surf).group(group_surf_yhi).number(temp_boundary_yhi) and convert to K
str = io['input.group(boundary).group(surf).group(group_surf_yhi).number(temp_boundary_yhi).current'].value
temp_boundary_yhi = Rappture.Units.convert(str, to="K", units="off")

# get input value for input.group(boundary).group(surf).group(group_surf_yhi).number(acc_boundary_yhi)
acc_boundary_yhi = float(io['input.group(boundary).group(surf).group(group_surf_yhi).number(acc_boundary_yhi).current'].value)

# get input value for input.group(surface).group(group_surface_collision).group(group_sq2).boolean(value34)
# returns value as string "yes" or "no"
value34 = io['input.group(surface).group(group_surface_collision).group(group_sq2).boolean(value34).current'].value == 'yes'

# get input value for input.group(surface).group(group_surface_collision).group(group_sq2).number(temp_square2) and convert to K
str = io['input.group(surface).group(group_surface_collision).group(group_sq2).number(temp_square2).current'].value
temp_square2 = Rappture.Units.convert(str, to="K", units="off")

# get input value for input.group(surface).group(group_surface_collision).group(group_sq2).number(acc_square2)
acc_square2 = float(io['input.group(surface).group(group_surface_collision).group(group_sq2).number(acc_square2).current'].value)


#########################################################
#  Add your code here for the main body of your program
#########################################################

del str

# create air.vss file
f = open("air.vss", "w")
f.write("# VSS collision model parameters for each species\n");
f.write('# ID, diameter, omega, tref, alpha\n\n');
f.write('O2   4.07e-10   0.77  273.15  1.4\n');
f.write('N2   4.17e-10   0.74  273.15  1.6\n');
f.write('O    3.00e-10   0.80  273.15  1.0\n');
f.write('N    3.00e-10   0.80  273.15  1.0\n');
f.write('NO   4.00e-10   0.80  273.15  1.0\n');
f.write('Ar   4.70e-10   0.81  273.15  1.0\n');
f.write('He   2.33e-10   0.66  273.15  1.0\n');
f.close();

# create air.species file
f = open('air.species', 'w');
f.write('# Species data\n');
f.write('# Id, Molwt, Molmass, Rot dof, RotRel, Vib dof, VibRel, VibTemp, species wt, charge\n\n');
f.write('O2  32.00    5.31E-26  2    0.2   2    5.58659E-5    2256.0    1.0      0.0\n');
f.write('N2  28.016   4.65E-26  2    0.2   2    1.90114E-5    3371.0    1.0      0.0\n');
f.write('O   16.00    2.65E-26  0    0.0   0    0.0           0.0       1.0      0.0\n');
f.write('N   14.008  2.325E-26  0    0.0   0    0.0           0.0       1.0      0.0\n');
f.write('NO  30.008   4.98E-26  2    0.2   2    7.14285E-4    2719.0    1.0      0.0\n');
f.write('Ar  40.00    6.63E-26  0    0.0   0    0.0           0.0       1.0      0.0\n');
f.write('He  4.003   6.647E-27  0    0.0   0    0.0           0.0       1.0      0.0\n');
f.close()

# spit out progress messages as you go along...
Rappture.Utils.progress(0, "Starting...")

# Create Surface File
sq1 = open("sq1.dat", "w")
sq1.write("Surface file of first rectangle\n\n");
sq1.write("4 points\n4 lines\n\nPoints\n\n");
sq1.write("1 %s %s\n" % (xlo_s, ylo_s));
sq1.write("2 %s %s\n" % (xlo_s, yhi_s));
sq1.write("3 %s %s\n" % (xhi_s, yhi_s));
sq1.write("4 %s %s\n" % (xhi_s, ylo_s));
sq1.write("\nLines\n\n");
sq1.write("1 1 2\n2 2 3\n3 3 4\n4 4 1");
sq1.close();

# Create second Surface file if necessary
if value29:
	sq2 = open("sq2.dat", "w");
	sq2.write("surf file\n\n");
	sq2.write("4 points\n4 lines\n\nPoints\n\n");
	sq2.write("1 %s %s\n" % (xlo_2s, ylo_2s));
	sq2.write("2 %s %s\n" % (xlo_2s, yhi_2s));
	sq2.write("3 %s %s\n" % (xhi_2s, yhi_2s));
	sq2.write("4 %s %s\n" % (xhi_2s, ylo_2s));
	sq2.write("\nLines\n\n");
	sq2.write("1 1 2\n2 2 3\n3 3 4\n4 4 1");
	sq2.close();

# Open input file for Sparta

fid = open("in.circle", "w");

# Write out header of the input file. The user has no control over this.
fid.write("#SPARTA input file\n\nseed 12435\ndimension 2\nglobal gridcut 0.0 comm/sort yes\n\n");

# Write out the boundary conditions
fid.write("boundary ");

if xlo == "1":
	xhi =  "5";


if xhi == '1':
	xlo = '5';


if ylo == '1':
	yhi =  '5';


if yhi == '1':
	ylo = '5';

if xlo == '1' or xhi == '1':
	fid.write('p ');

if xlo == '2':
	fid.write('o');
elif (xlo == '3'):
	fid.write('r');
elif (xlo == '4'):
	fid.write('s');

if xhi == '2':
	fid.write('o ');
elif (xhi == '3'):
	fid.write('r ');
elif (xhi == '4'):
	fid.write('s ');

if ylo == '1' or yhi == '1':
	fid.write('p ');

if ylo == '2':
	fid.write('o');
elif ylo == '3':
	fid.write('r');
elif ylo == '4':
	fid.write('s');

if yhi == '2':
	fid.write('o ');
elif yhi == '3':
	fid.write('r ');
elif yhi == '4':
	fid.write('s ');

fid.write('p\n\n');

# The following prints out the boundary surface collision properties if necessary

if xlo == '4' and xhi != '1':
    fid.write('surf_collide xlowall ');
    if bound_collide_xlo:
        fid.write('diffuse %s %s\n' % (temp_boundary_xlo, acc_boundary_xlo));
    else:
        fid.write('specular\n');
    fid.write('bound_modify xlo collide xlowall\n\n');

if ylo == '4' and yhi != '1':
    fid.write('surf_collide ylowall ');
    if bound_collide_ylo:
        fid.write('diffuse %s %s\n' % (temp_boundary_ylo, acc_boundary_ylo));
    else:
        fid.write('specular\n');
    fid.write('bound_modify ylo collide ylowall\n\n');

if xhi == '4' and xlo != '1':
    fid.write('surf_collide xhiwall ');
    if bound_collide_xhi:
        fid.write('diffuse %s %s\n' % (temp_boundary_xhi, acc_boundary_xhi));
    else:
        fid.write('specular\n');
    fid.write('bound_modify xhi collide xhiwall\n\n');


if yhi == '4' and ylo != '1':
    fid.write('surf_collide yhiwall ');
    if bound_collide_yhi:
        fid.write('diffuse %s %s\n' % (temp_boundary_yhi, acc_boundary_yhi));
    else:
        fid.write('specular\n');
    fid.write('bound_modify yhi collide yhiwall\n');


# Write the create_box command
fid.write('\ncreate_box %s %s %s %s -0.5 0.5\n\n' % (start_x, end_x, start_y, end_y));

# Write the create_grid command
fid.write('create_grid %d %d 1\n\n' % (grid_x, grid_y));

# Command that user doesn't control
fid.write('balance_grid rcb cell\n\n');

# Calculate ambient pressure or number density
k = 1.3806488e-23;
if value38:
	nrho = press/(k*temp_stream);
else:
	press = nrho*k*temp_stream;

# Calculate fnum
Nreal = nrho * (end_x-start_x) * (end_y-start_y);
Nsim = num * grid_x * grid_y;
fnum = Nreal/Nsim;

# Define nrho and fnum
fid.write('global nrho %s fnum %s\n\n' % (nrho, fnum));

# Define gas mixture
if air == '1':
	fid.write('species air.species N2\n');
	fid.write('mixture air N2 vstream %s %s 0 temp %s\n' % (vel_x, vel_y, temp_stream));
	fid.write('mixture air N2 frac 1.0\n\n');
elif air == '2':
	fid.write('species air.species N2 O2 Ar\n');
	fid.write('mixture air N2 O2 Ar vstream %s %s 0 temp %s\n' % (vel_x, vel_y, temp_stream));
	fid.write('mixture air N2 frac .78\n');
	fid.write('mixture air O2 frac .21\n');
	fid.write('mixture air Ar frac .01\n\n');
elif air == '3':
	fid.write('species air.species He\n');
	fid.write('mixture air He vstream %s %s 0 temp %s\n' % (vel_x, vel_y, temp_stream));
	fid.write('mixture air He frac 1.0\n\n');


# Read surface file and define surface properties
fid.write('read_surf sq1.dat group sq1\n');
fid.write('surf_collide sq1_ ');
if value30:
	fid.write('diffuse %d %d\n' % (temp_square, acc_square));
else:
	fid.write('specular\n');

fid.write('surf_modify sq1 collide sq1_\n\n');

# Read second surface file if necessary
if value29:
	fid.write('read_surf sq2.dat group sq2\n');
	fid.write('surf_collide sq2_ ');
	if value34:
		fid.write('diffuse %d %d\n' % (temp_square2, acc_square2));
	else:
		fid.write('specular\n');
	fid.write('surf_modify sq2 collide sq2_\n\n');
	

# Commands that user doesn't control
fid.write('global surfpush yes\n\n');
fid.write('collide vss air air.vss\n\n');

# Inflow Conditions
if xlo == '1':
	xlo_flow = 0;
	xhi_flow = 0;

if xhi == '1':
	xlo_flow = 0;
	xhi_flow = 0;

if ylo == '1':
	ylo_flow = 0;
	yhi_flow = 0;

if yhi == '1':
	ylo_flow = 0;
	yhi_flow = 0;


if flow:
	if xlo_flow or ylo_flow or xhi_flow or yhi_flow:
		fid.write('fix in emit/face air ');
	if xlo_flow:
		fid.write('xlo ');
	if ylo_flow:
		fid.write('ylo ');
	if xhi_flow:
		fid.write('xhi ');
	if yhi_flow:
		fid.write('yhi ');
	fid.write('\n');

# Create Particles
if create_par != 0:
	fid.write('\ncreate_particles air n %s\n\n' % (create_par));

# Timestep
fid.write('timestep %s\n\n' % (timestep));


# stats and stats_style outputs. Currently not controlled by the user
fid.write('stats 10\n');
fid.write('stats_style step cpu np nattempt ncoll nscoll nscheck\n');


# Compute, fix, and dump commands for grid
fid.write('compute cgrid grid all n temp ke u v w nrho\n');
fid.write('fix fgrid ave/grid 1 %s %s c_cgrid ave running\n' % (run, run));
fid.write('dump dgrid grid all %s properties_grid.* id xc yc f_fgrid\n\n' % (run));

# Compute, fix, and dump commands for surface
fid.write('compute csurf surf all all n press px py shx shy ke erot evib etot\n');
fid.write('fix fsurf ave/surf all 1 %s %s c_csurf ave running\n' % (run, run));
fid.write('dump dsurf surf all %s properties_surf.* id v1x v1y v2x v2y f_fsurf\n\n' % (run));

# Run command
fid.write('run %s' % (run));


fid.close()

Rappture.Utils.progress(5, "Running SPARTA")

#exitCode,strOut,strErr = RapptureExec(['spa_serial','-in','in.circle'],True)

if value29:
	exitCode,strOut,strErr = RapptureExec(['submit','--wallTime','300','--nCpus','32','--inputfile','air.vss','--inputfile','sq1.dat','--inputfile','sq2.dat','--inputfile','air.species','--tailStdout','sparta-21Aug15-parallel','-in','in.circle'],True)
else:
	exitCode,strOut,strErr = RapptureExec(['submit','--wallTime','300','--nCpus','32','--inputfile','air.vss','--inputfile','sq1.dat','--inputfile','air.species','--tailStdout','sparta-21Aug15-parallel','-in','in.circle'],True)

Rappture.Utils.progress(95, "Finished Running SPARTA!")

# Read properties_grid and properties_surf files
prop_grid = 'properties_grid.' + str(int(run));
prop_surf = "properties_surf." + str(int(run));

# Take out first 9 lines of the properties_grid file
f = open(prop_grid, 'r');
lines = f.readlines();
with open(prop_grid, 'r') as fin:
	data = fin.read().splitlines(True)
with open(prop_grid, 'w') as fout:
	fout.writelines(data[9:]);
f.close();

# Attempt to add a header to the grid properties
#f = open(output_grid, 'w');
#f.write('# Here are the grid properties.\n')
#f.write('# You can copy this file into any visualization software you want such as Tecplot or paraview to see the flowfield.\n');
#f.write('# Note that the flowfields are also shown in these outputs.\n');
#f.write('# Please note that all of the following variables give the property for each individual grid cell\n');
#f.write('# ID, X, Y, number of particles, temperature, kinetic energy, Velocity_x, Velocity_y, Velocity_z, Number Density\n');
#f.close();

# Copy properties_grid file to properties_grid.txt
shutil.copyfile(prop_grid, output_grid)

# Take out first 9 lines of the properties_surf file
f = open(prop_surf, 'r');
lines = f.readlines();
with open(prop_surf, 'r') as fin:
	data = fin.read().splitlines(True)
with open(prop_surf, 'w') as fout:
	fout.writelines(data[9:]);
f.close();

# Copy properties_surf file to properties_surf.txt
shutil.copyfile(prop_surf, output_surf)

# Load surface data to compute Knudsen force
data = np.loadtxt(output_surf)

# Take coordinates of first rectangular surface
v1x = data[0:4, 1].T;
v1y = data[0:4, 2].T;
v2x = data[0:4, 3].T;
v2y = data[0:4, 4].T;

v1 = [v1x, v1y];
v2 = [v2x, v2y];

surf_length = np.absolute([v1_i- v2_i for v1_i, v2_i in zip(v1, v2)]);

delta_x = surf_length[0,:];
delta_y = surf_length[1,:];

# Load the pressure
px = data[0:4,7];
py = data[0:4,8];

# Load the shear stress
shx = data[0:4,9];
shy = data[0:4,10];

# Calculate the pressure contribution of Knudsen Force
Fx = 0;
Fy = 0;
for i in range(0,4):
	Fx = Fx + px[i]*delta_y[i];
	Fy = Fy + py[i]*delta_x[i];


# Add the shear stress contribution of Knudsen Force
for k in range(0,4):
	Fx = Fx + shx[k]*delta_x[k];
	Fy = Fy + shy[k]*delta_y[k];

# Take coordinates of second rectangular surface
if value29:
	v1x_2 = data[4:8, 1];
	v1y_2 = data[4:8, 2];
	v2x_2 = data[4:8, 3];
	v2y_2 = data[4:8, 4];
	v1_2 = [v1x_2, v1y_2]
	v2_2 = [v2x_2, v2y_2]
	surf_length_2 = np.absolute([v1_2_i - v2_2_i for v1_2_i, v2_2_i in zip(v1_2, v2_2)]);

	delta_x2 = surf_length_2[0,:];
	delta_y2 = surf_length_2[1,:];

	# Load the pressure
	px_2 = data[4:8,7];
	py_2 = data[4:8,8];

	# Load the shear stress
	shx_2 = data[4:8,9];
	shy_2 = data[4:8,10];
	
	# Calculate the pressure contribution of Knudsen Force
	Fx_2 = 0;
	Fy_2 = 0;
	
	for j in range(1,4):
		Fx_2 = Fx_2 + px_2[j]*delta_y2[j];
		Fy_2 = Fy_2 + py_2[j]*delta_x2[j];
        
	# Add the shear stress contribution of Knudsen Force
	for l in range(1,4):
		Fx_2 = Fx_2 + shx_2[l]*delta_x2[l];
		Fy_2 = Fy_2 + shy_2[l]*delta_y2[l];

# Heat Flux
etot = data[:, 14];
etot1 = sum(etot[0:4]);
if value29:
	etot2 = sum(etot[5:8]);

f = open('surf_force_data.txt','w');
f.write('#Surface 1: Lower Coordinate: (%s, %s), Higher Coordinate: (%s, %s)\n' % (xlo_s, ylo_s, xhi_s, yhi_s));
f.write('#Ambient Pressure (Pa),   Force_x (N),  Force_y (N), Heat Flux\n');
f.write('%s    %s    %s     %s\n' % (press, Fx, Fy, etot1));

if value29:
	f.write('\n#Surface 2: Lower Coordinate: (%s, %s), Higher Coordinate: (%s, %s)\n' % (xlo_2s, ylo_2s, xhi_2s, yhi_2s));
	f.write('#Ambient Pressure (Pa),   Force_x (N),   Force_y (N), Heat Flux\n');
	f.write('%s    %s    %s     %s\n' % (press, Fx_2, Fy_2, etot2));

f.close();

# Prepare data for post processing
grid_prop = np.loadtxt(output_grid);
X = grid_prop[:,1];
Y = grid_prop[:,2];
num = grid_prop[:,3];
temp = grid_prop[:,4];
u = grid_prop[:,6];
v = grid_prop[:,7];
vel = np.sqrt(np.power(u,2) + np.power(v,2));
nrho = grid_prop[:,8];

# Create output of surface properties
f = open('surf_force_data.txt','r');
propstr = f.read()
f.close()

# Create output for the log file
f = open('log.sparta','r');
log = f.read()
f.close()

# Create output for properties_grid.txt
f = open(output_grid, 'r');
grid = f.read()
f.close()

# Create output for properties_surf.txt
f = open(output_surf, 'r');
surf = f.read();
f.close()

# Give the user the SPARTA input file
f = open('in.circle','r');
inputfile = f.read();
f.close()

# Give the user a surface file
f = open('sq1.dat', 'r');
sq = f.read();
f.close()

# Creating variables for contour plot

string_temp = '\n'.join([str(x) for x in temp]);
string_nrho = '\n'.join([str(x) for x in nrho]);
string_num = '\n'.join([str(x) for x in num]);
string_vel = '\n'.join([str(x) for x in vel]);

#fwrite
Rappture.Utils.progress(100, "Done")

#########################################################
# Save output values back to Rappture
#########################################################

# save output value for output.string(propstr)
io['output.string(propstr).current'] = propstr

# save output value for output.string(grid)
io['output.string(grid).current'] = grid

# save output value for output.string(surf)
io['output.string(surf).current'] = surf

# save output value for output.string(log)
io['output.string(log).current'] = log

# save output value for output.string(input)
io['output.string(input).current'] = inputfile

# save output value for output.string(sq1_file)
io['output.string(sq1_file).current'] = sq

# Creating mesh
io['output.mesh(mesh_temp).grid.xaxis.min'] = str(start_x);
io['output.mesh(mesh_temp).grid.xaxis.max'] = str(end_x);
io['output.mesh(mesh_temp).grid.yaxis.min'] = str(start_y);
io['output.mesh(mesh_temp).grid.yaxis.max'] = str(end_y);
io['output.mesh(mesh_temp).grid.xaxis.numpoints'] = str(grid_x);
io['output.mesh(mesh_temp).grid.yaxis.numpoints'] = str(grid_y);
io['output.mesh(mesh_temp).dim'] = "2";

# Output Contour
io['output.field(field_temp).component.values'] = string_temp;
io['output.field(field_num).component.values'] = string_num;
io['output.field(field_nrho).component.values'] = string_nrho;
io['output.field(field_vel).component.values'] = string_vel;



io.close()
sys.exit()
